package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.command.*;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPINFO_InputDto;
import com.tmax.openframe.dto.OIVPINFO_OutputDto;
import com.tmax.openframe.variable.OIVPINFO_VariableContainer;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPINFO implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPINFO_VariableContainer container = new OIVPINFO_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPINFO_InputDto inputDto;
    @Getter
    @Setter
    OIVPINFO_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPINFO() {
    }

    public @Override void run() {
        run(_0000_MAIN);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        // ("EXEC CICS ASKTIME ABSTIME(WS-ASKTIME) END-EXEC");
        try {
            AskTimeOption option = AskTimeOption.builder()
                    .abstime(container.getWS_ASKTIME()).build();
            IntervalControlService.asktime(option);
            container.setWS_ASKTIME(option.getAbstime().longValue());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS FORMATTIME ABSTIME(WS-ASKTIME) DATESEP('/') MMDDYY(WS-DATE) END-EXEC");
        try {
            FormatTimeOption option = FormatTimeOption.builder()
                    .abstime((long) container.getWS_ASKTIME()).datesep("/")
                    .mmddyy(container.getWS_DATE()).build();
            IntervalControlService.formattime(option);
            container.setWS_DATE(option.getMmddyy());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.getWS_RAW_TIME().setWS_TIME(
                Integer.parseInt(eib.getEibTime()));
        container.getDFHCOMMAREA().getDCA_TIME().setDCA_COLON(":");
        container
                .getDFHCOMMAREA()
                .getDCA_TIME()
                .setDCA_TIME_MIN(
                        String.valueOf(container.getWS_RAW_TIME().getWS_MIN()));
        container.getDFHCOMMAREA().setDCA_DATE(container.getWS_DATE());
        container.getDFHCOMMAREA().setDCA_TERM(eib.getEibTrmid());
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                outputDto
                        .getSystemDto()
                        .setCommarea(
                                "DFHCOMMAREA",
                                OIVPINFO_DFHCOMMAREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                        .toOIVPINFO_DFHCOMMAREADto(container
                                                .getDFHCOMMAREA()));
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
